#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include <string>
#include <fcntl.h>
#include <unistd.h>
#include <stdint.h>
#include <sys/stat.h>
#include <list>
#include <vector>
#include <dirent.h>
#include <sys/types.h>
#include <inttypes.h>
#include <iostream>
#include <thread>


#include "tcfs.h"




/************************user info*****************************/
struct WalletT
{
    std::string keyjson;
    std::string address;
    std::string password;
};

#define WALLET_NUM 2  // Change this only if you need more than 2 wallets.

int curWalletIndex = 0;
WalletT wallet[WALLET_NUM]; 

// Change these to your own appid and sign.
std::string appid = "17b4cf0dfd7fbce35b917677093b917a040552df30979f2d1cb4ded051046856";
std::string appSign = "ea6438086f372f6ad9b8e341d78dea70";//appSign=MD5(appid+appkey+ts), ts is expire time(unix timestamp)

int walletInit() 
{
	// Change these according to your own wallet.
    wallet[0].keyjson = "{\
        \"address\":\"0fc37d644350f29a37f7a589056670efbaeb20ca\",\
        \"crypto\":{\"cipher\":\"aes-128-ctr\",\"ciphertext\":\"1eb8770334663d4649e446f7b0948a344fdfe571e74ad2e369e2ae23900dee68\",\
        \"cipherparams\":{\"iv\":\"e009ec438c4374b0e55a25e4f563f95b\"},\
        \"kdf\":\"scrypt\",\"kdfparams\":{\"dklen\":32,\"n\":4096,\"p\":6,\"r\":8,\"salt\":\"134f661825996543fb43d89daa55e5ffb5b706731a66fc5b26ad59503145ce20\"},\
        \"mac\":\"4bcd5086eee3c0328690df3e80825804a16c08c52336b47544f8f30e29339de3\"},\"id\":\"fb35d736-5dcb-41d2-baf3-4e72283d35b9\",\"version\":3}";
    wallet[0].address = "0x0fc37d644350f29a37f7a589056670efbaeb20ca";
    wallet[0].password = "12345678";

	// Ignore these if you're not testing copy function, otherwise change these to dest addr.
    wallet[1].keyjson = "{\
        \"address\":\"8c5fa76cf8f27cbc84ab700428d5b2592ba38266\",\"crypto\":{\"cipher\":\"aes-128-ctr\",\
        \"ciphertext\":\"91e3990178b014143ec81ace6e827fb71d658e99d602199fdce132fa8e39824b\",\
        \"cipherparams\":{\"iv\":\"554a1aa9ef16847dddfe74188c1b3c22\"},\"kdf\":\"scrypt\",\"kdfparams\":{\
        \"dklen\":32,\"n\":4096,\"p\":6,\"r\":8,\"salt\":\"7b32ac533f38403c72931c10e57fe23f656767aca70be0d5c2ca57038339634b\"},\
        \"mac\":\"f9dccc5faefb81a44fdb26c963c0309cc61df3afe4a63be0659b00b1d0f27ba8\"},\"id\":\"cc730321-d280-41e7-adde-afe6da834367\",\"version\":3}";
    wallet[1].address = "0x8c5fa76cf8f27cbc84ab700428d5b2592ba38266";
    wallet[1].password = "12345678";

}
/*******************************************************/


 void printCmdHint()
 {
     printf("*****Please input command to continue: split with space.*****\n");     
     printf("## display version,FORMAT:version(eg: version)\n");     
     printf("## upload file,FORMAT:upload filepath tcfspath isDir[0:file,1:dir](eg: upload test.txt /tcfs/::::/newest/mytest/ 0).\n");
     printf("## download file,FORMAT:download dirpath tcfspath isDir[0:file,1:dir](eg: download . /tcfs/::::/newest/mytest/test.txt 0).\n");     
     printf("## delete file,FORMAT:delete tcfspath isDir[0:file,1:dir](eg: delete /tcfs/::::/newest/mytest/test.txt 0).\n");
     printf("## sign file,FORMAT:sign filepath walletNum(eg: sign /tcfs/::::/newest/mytest/test.txt 1).\n");
     printf("## copy file,FORMAT:copy signpath tcfspath(eg: copy signpath /tcfs/::::/newest/mytest/).\n");     
     printf("## display entry tree,FORMAT:tree tcfspath(eg: tree /tcfs/::::/newest/mytest/test.txt).\n");     
     printf("## display dir,FORMAT:ls tcfspath(eg: ls /tcfs/::::/newest/mytest/).\n");     
     printf("## display wallet information,FORMAT:wallet(eg: wallet).\n");          
     printf("## display total space/used space,FORMAT:space(eg: space)\n");     
     printf("## auto test,FORMAT:auto loop(eg: auto 10).\n");     
     printf("## autoup test,FORMAT:autoup filepath tcfspath idDir loop(eg: autoup test.txt /tcfs/::::/newest/mytest/ 0 10).\n");     
     printf("## autodown test,FORMAT:autodown dirpath tcfspach isDir loop(eg: autodown . /tcfs/::::/newest/mytest/test.txt 0 10).\n");
 }
 void split(const  std::string& s, const std::string& delim,std::vector<std::string> &elems) 
 {
     size_t pos = 0;
     size_t len = s.length();
     size_t delim_len = delim.length();
     if (delim_len == 0) return;
     while (pos < len)
     {
         int find_pos = s.find(delim, pos);
         if (find_pos < 0)
         {
             elems.push_back(s.substr(pos, len - pos));
             break;
         }
         elems.push_back(s.substr(pos, find_pos - pos));
         pos = find_pos + delim_len;
     }
     return;
 }



 int SignShareTcfsPath(int curWalletIndex, std::string toWalletAddr, std::string shareTcfsPath, std::string &signTcfsPath)
 {
    int expireTime = 1566740935;
     int pos = shareTcfsPath.find("/", 6);
     
     std::string subTcfsPath = shareTcfsPath.substr(pos);
     uint64_t signTs = expireTime;
 
     std::string tcfsSignData = wallet[curWalletIndex].address + toWalletAddr + std::to_string(signTs) + subTcfsPath;
 
     char tsfsSign[1024] = {0};
     int ret = TCFS_UserSign(wallet[curWalletIndex].keyjson.c_str(), wallet[curWalletIndex].password.c_str(), tcfsSignData.c_str(), tsfsSign, sizeof(tsfsSign));
     if(ret != 0)
     {
         printf("UserSign failed\n");
         return -1;
     }
 
     printf("tcfsSignData:%s, sign:%s\n", tcfsSignData.c_str(), tsfsSign);    
     std::string signData = std::string(tsfsSign);
     signTcfsPath = "/tcfs/" + wallet[curWalletIndex].address + ":" + toWalletAddr + ":" + std::to_string(signTs) + ":" + signData + ":" + std::to_string(subTcfsPath.size()) + subTcfsPath;
     printf("signTcfsPath:%s\n", signTcfsPath.c_str());
     return 0;
 }

int processSign(int curWalletIndex, TCFSAppCertification *appCert, TCFSUserCertification *userCert)
{
    uint64_t expireTime = 1566740935;

    memset(appCert, 0, sizeof(TCFSAppCertification));
    strcpy(appCert->appid, appid.c_str());            
    strcpy(appCert->appSign, appSign.c_str());
    appCert->timestamp = expireTime;
    std::string signData = wallet[curWalletIndex].address + appid + std::to_string(expireTime);
    char sign[1024] = {0};
    memset(sign, 0, 1024);
    int ret = TCFS_UserSign(wallet[curWalletIndex].keyjson.c_str(), wallet[curWalletIndex].password.c_str(), signData.c_str(), sign, sizeof(sign));
    if(ret != 0)
    {
        printf("UserSign failed\n");
        return -1;
    }

    memset(userCert, 0, sizeof(TCFSUserCertification));
    strcpy(userCert->address, wallet[curWalletIndex].address.c_str());
    printf("sign:%s\n", sign);
    strcpy(userCert->userSign, sign);
    userCert->timestamp = expireTime;
    return 0;

}

 void upload(std::string tcfsPath, std::string srcPath, int thread)
 {
     printf("upload thread %d start\n", thread);
     std::string path = tcfsPath + std::to_string(thread);
     TCFSAppCertification appCert;
     TCFSUserCertification userCert;
     
     if(processSign(curWalletIndex, &appCert, &userCert) != 0)
         return;
     std::string srcFilePath = srcPath + "/test";
     if(TCFS_Upload(&appCert, &userCert, srcFilePath.c_str(), path.c_str(), 0) != 0)
         printf("***wallet %d upload %s to %s failed\n", curWalletIndex, srcFilePath.c_str(), path.c_str());
     else
         printf("***wallet %d upload %s to %s ok\n", curWalletIndex, srcFilePath.c_str(), path.c_str());
     printf("upload thread %d end\n", thread);
 }

 void download(std::string tcfsPath, std::string dstPath, int thread)
 {
     printf("download thread %d start\n", thread);
     TCFSAppCertification appCert;
     TCFSUserCertification userCert;
     
     if(processSign(curWalletIndex, &appCert, &userCert) != 0)
         return;

         
     if(TCFS_Download(&appCert, &userCert, dstPath.c_str(), tcfsPath.c_str(), 0) != 0)
         printf("***wallet %d download %s to %s failed\n", curWalletIndex, tcfsPath.c_str(), dstPath.c_str());
     else
         printf("***wallet %d download %s to %s ok\n", curWalletIndex, tcfsPath.c_str(), dstPath.c_str());
     printf("download thread %d end\n", thread);
 }

 int processCmd(std::vector<std::string> &procCmd, int loop)
{
    walletInit();

    TCFS_Init();
    
#define SIGN_LEN  (1*1024)

    printCmdHint();

    int cnt = 1;
    
    std::vector<std::string> cmd;
    while(1)
    {
        if(loop == 0)
        {
            if(cnt <= 0)
                break;
            cnt--;
            cmd = procCmd;
        }
        else
        {
            std::string inputStr;
            getline(std::cin, inputStr);
            int len = inputStr.size();
            if (len <= 0)
            {
                printCmdHint();
                continue;
            }
            cmd.clear();
            split(inputStr," ", cmd);
        }
        if(cmd.empty())
        {
            printCmdHint();
            continue;
        }
        if (strcmp(cmd[0].c_str(), "version") == 0) 
        {
        #define VERSION_LEN 64
            char version[VERSION_LEN];
            memset(version, 0, VERSION_LEN);
            TCFS_GetVersion(version, VERSION_LEN);
            printf("current version is:%s\n", version);            
            continue;
        }
        else if (strcmp(cmd[0].c_str(), "help") == 0) 
        {
            printCmdHint();
            continue;
        }
        else if (strcmp(cmd[0].c_str(), "upload") == 0) 
        {
            if (cmd.size() < 4)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }            
            int isDir = atoi(cmd[3].c_str());
            
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            
            if(TCFS_Upload(&appCert, &userCert, cmd[1].c_str(), cmd[2].c_str(), isDir) != 0)
                printf("***wallet %d upload %s to %s failed\n",curWalletIndex, cmd[1].c_str(), cmd[2].c_str());
            else
                printf("***wallet %d upload %s to %s ok\n",curWalletIndex, cmd[1].c_str(), cmd[2].c_str());
        }
        else if(strcmp(cmd[0].c_str(), "download") == 0)
        {
            if (cmd.size() < 4)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }
            int isDir = atoi(cmd[3].c_str());
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_Download(&appCert, &userCert, cmd[1].c_str(), cmd[2].c_str(), isDir) != 0)
                printf("***wallet %d download %s to %s failed\n",curWalletIndex, cmd[2].c_str(), cmd[1].c_str());
            else
                printf("***wallet %d download %s to %s ok\n",curWalletIndex, cmd[2].c_str(), cmd[1].c_str());
        }
        else if(strcmp(cmd[0].c_str(), "delete") == 0)
        {
            if (cmd.size() < 3)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }            
            
            int isDir = atoi(cmd[2].c_str());

            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;            
            if(TCFS_Delete(&appCert, &userCert, cmd[1].c_str(), isDir) != 0)
                printf("***wallet %d delete %s failed\n",curWalletIndex, cmd[1].c_str());
            else
                printf("***wallet %d delete %s ok\n",curWalletIndex, cmd[1].c_str());
        }
        else if(strcmp(cmd[0].c_str(), "space") == 0)
        {
            if (cmd.size() < 1)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }            
            uint64_t totalSize, usedSize;
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_GetSpace(&appCert, &userCert, &totalSize, &usedSize) != 0)
                printf("***wallet %d get space failed\n",curWalletIndex);
            else
                printf("***wallet %d get space ok, total:%" PRIu64 ", used:%" PRIu64 "\n",curWalletIndex, totalSize, usedSize);
        }
        else if(strcmp(cmd[0].c_str(), "tree") == 0)
        {
            if (cmd.size() < 2)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }              
        #define TREE_NODE_NUM  100
            TreeNodeT node[TREE_NODE_NUM];
            int realNum =0;

            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
                
            if(TCFS_ListTree(&appCert, &userCert, cmd[1].c_str(), node, TREE_NODE_NUM, &realNum) != 0)
                printf("***wallet %d tree %s failed\n",curWalletIndex, cmd[1].c_str());
            else
            {
                printf("***wallet %d tree %s ok\n",curWalletIndex, cmd[1].c_str());
                
                int num = (realNum > TREE_NODE_NUM)?TREE_NODE_NUM : realNum;
                for(int i = 0; i < num; i++)
                {
                    printf("wallet %d node %d[path:%s,hash:%s,ctime:%" PRIu64 ",size:%" PRIu64 ",type:%s]\n",curWalletIndex, i, node[i].path, node[i].hash, node[i].ctime, node[i].size, node[i].type?"dir":"file");
                }
            }
        }
        else if(strcmp(cmd[0].c_str(), "ls") == 0)
        {
            if (cmd.size() < 2)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }              
        #define DIR_NODE_NUM  100   
            TreeNodeT node[DIR_NODE_NUM];
            int realNum =0;

            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_ListDir(&appCert, &userCert, cmd[1].c_str(), 0, 100, node, DIR_NODE_NUM, &realNum) != 0)
               printf("***wallet %d ls %s failed\n",curWalletIndex, cmd[1].c_str());
            else
            {
                printf("***wallet %d ls %s ok\n",curWalletIndex, cmd[1].c_str());
                int num = (realNum > DIR_NODE_NUM)?DIR_NODE_NUM : realNum;
                for(int i = 0; i < num; i++)
                {
                    printf("wallet %d node %d[path:%s,hash:%s,ctime:%" PRIu64 ",size:%" PRIu64 ",type:%s]\n",curWalletIndex, i, node[i].path, node[i].hash, node[i].ctime, node[i].size, node[i].type?"dir":"file");
                }
            }
        }
        else if(strcmp(cmd[0].c_str(), "sign") == 0)
        {
            if (cmd.size() < 3)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }            
            std::string signTcfsPath;
            int num = atoi(cmd[2].c_str());
            if(num >= WALLET_NUM)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }                 
            if(SignShareTcfsPath(curWalletIndex, wallet[num].address.c_str(), cmd[1].c_str(), signTcfsPath) != 0)
               printf("***wallet %d sign %s to wallet %d failed\n",curWalletIndex, cmd[1].c_str(), num);
            else
            {
                printf("***wallet %d sign %s to wallet %d ok\n",curWalletIndex, cmd[1].c_str(), num);               
                printf("signTcfsPath:%s\n", signTcfsPath.c_str());
            }
        }
        else if(strcmp(cmd[0].c_str(), "copy") == 0)
        {
            if (cmd.size() < 2)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }            
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_Copy(&appCert, &userCert, cmd[1].c_str(), cmd[2].c_str()) != 0)
                printf("***wallet %d copy %s to %s failed\n", curWalletIndex, cmd[1].c_str(), cmd[2].c_str());
            else
                printf("***wallet %d copy %s to %s ok\n", curWalletIndex, cmd[1].c_str(), cmd[2].c_str());
        }
        else if(strcmp(cmd[0].c_str(), "switch") == 0)
        {
            if (cmd.size() < 2)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }     
            
            int num = atoi(cmd[1].c_str());
            if(num >= WALLET_NUM)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }                 
            printf("***switch wallet %d->%d\n", curWalletIndex, num);
            curWalletIndex = num;
        }
        else if(strcmp(cmd[0].c_str(), "wallet") == 0)
        {
            if (cmd.size() < 1)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }     
 
            printf("***wallet:%d,wallet addr:%s\n", curWalletIndex, wallet[curWalletIndex].address.c_str());
        }  
        else if(strcmp(cmd[0].c_str(), "multiup") == 0)
        {
            std::string uploadPath = "myupload";
            std::string uploadTcfsPath = "/tcfs/::::/newest/multithread";            
            if (cmd.size() < 1)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }     
            if(access(uploadPath.c_str(), R_OK|W_OK) != 0)
            {
                printf("can not find %s folder!\n", uploadPath.c_str());
                printCmdHint();
                continue;

            }

            std::thread t0(upload, uploadTcfsPath, uploadPath, 0);
            std::thread t1(upload, uploadTcfsPath, uploadPath, 1);
            std::thread t2(upload, uploadTcfsPath, uploadPath, 2);
            std::thread t3(upload, uploadTcfsPath, uploadPath, 3);
            std::thread t4(upload, uploadTcfsPath, uploadPath, 4);
            std::thread t5(upload, uploadTcfsPath, uploadPath, 5);
            std::thread t6(upload, uploadTcfsPath, uploadPath, 6);
            std::thread t7(upload, uploadTcfsPath, uploadPath, 7);
            std::thread t8(upload, uploadTcfsPath, uploadPath, 8);
            std::thread t9(upload, uploadTcfsPath, uploadPath, 9);

            t0.join();
            t1.join();
            t2.join();
            t3.join();
            t4.join();
            t5.join();
            t6.join();
            t7.join();
            t8.join();
            t9.join();

            
        }  
        else if(strcmp(cmd[0].c_str(), "multidown") == 0)
        {
            std::string downloadPath = "mydownload";
            if (cmd.size() < 1)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }     

            for(int i = 0; i < 10; i++)
            {
                std::string path = downloadPath + std::to_string(i);
                if(access(path.c_str(), R_OK|W_OK) != 0)
                {
                    if(mkdir(path.c_str(), 0755) != 0)
                    {            
                        printf("mkdir %s failed!\n", path.c_str());
                        printCmdHint();
                        continue;
                    }    
                }       
            }


            std::string downloadTcfsPath = "/tcfs/::::/newest/multithread0/test";
            std::thread t10(download, downloadTcfsPath, downloadPath + "0", 0);
            std::thread t11(download, downloadTcfsPath, downloadPath + "1", 1);
            std::thread t12(download, downloadTcfsPath, downloadPath + "2", 2);
            std::thread t13(download, downloadTcfsPath, downloadPath + "3", 3);
            std::thread t14(download, downloadTcfsPath, downloadPath + "4", 4);
            std::thread t15(download, downloadTcfsPath, downloadPath + "5", 5);
            std::thread t16(download, downloadTcfsPath, downloadPath + "6", 6);
            std::thread t17(download, downloadTcfsPath, downloadPath + "7", 7);
            std::thread t18(download, downloadTcfsPath, downloadPath + "8", 8);
            std::thread t19(download, downloadTcfsPath, downloadPath + "9", 9);

            t10.join();
            t11.join();
            t12.join();
            t13.join();
            t14.join();
            t15.join();
            t16.join();
            t17.join();
            t18.join();
            t19.join();

            
        }  
        else if (strcmp(cmd[0].c_str(), "autodown") == 0) 
        {
            if (cmd.size() < 5)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }     
            
            int loop = atoi(cmd[4].c_str());            
            int isDir = atoi(cmd[3].c_str());
            int i = 0;
        startDown:
            
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_Download(&appCert, &userCert, cmd[1].c_str(), cmd[2].c_str(), isDir) != 0)
                printf("***wallet %d download %s to %s failed\n",curWalletIndex, cmd[2].c_str(), cmd[1].c_str());
            else
                printf("***wallet %d download %s to %s ok\n",curWalletIndex, cmd[2].c_str(), cmd[1].c_str());

            printf("***************************loop:%d, now:%d**************************\n", loop, ++i);
            if(i < loop)
                goto startDown;

        }
        else if (strcmp(cmd[0].c_str(), "autoup") == 0) 
        {
            if (cmd.size() < 5)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }            
            int loop = atoi(cmd[4].c_str());            
            int isDir = atoi(cmd[3].c_str());
            int i = 0;
        startUp:
            
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(curWalletIndex, &appCert, &userCert) != 0)
                return -1;
            
            if(TCFS_Upload(&appCert, &userCert, cmd[1].c_str(), cmd[2].c_str(), isDir) != 0)
                printf("***wallet %d upload %s to %s failed\n",curWalletIndex, cmd[1].c_str(), cmd[2].c_str());
            else
                printf("***wallet %d upload %s to %s ok\n",curWalletIndex, cmd[1].c_str(), cmd[2].c_str());
            printf("***************************loop:%d, now:%d**************************\n", loop, ++i);
            if(i < loop)
                goto startUp;
        }
        else if(strcmp(cmd[0].c_str(), "auto") == 0)
        {
            std::string uploadPath = "myupload";
            std::string downloadPath = "mydownload";
            std::string autoTcfsPath = "/tcfs/::::/newest/autotest";            
            std::string autoSignTcfsPath = "/tcfs/::::/newest/autotest";
            if (cmd.size() < 2)
            {
                printf("invalidate command caught!\n");
                printCmdHint();
                continue;
            }     
            if(access(uploadPath.c_str(), R_OK|W_OK) != 0)
            {
                printf("can not find %s folder!\n", uploadPath.c_str());
                printCmdHint();
                continue;

            }
            if(access(downloadPath.c_str(), R_OK|W_OK) != 0)
            {
                if(mkdir(downloadPath.c_str(), 0755) != 0)
                {            
                    printf("mkdir %s failed!\n", downloadPath.c_str());
                    printCmdHint();
                    continue;
                }    
            }            
            int loop = atoi(cmd[1].c_str());
            int i = 0;
        start:
            TCFSAppCertification appCert;
            TCFSUserCertification userCert;
            if(processSign(0, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_Upload(&appCert, &userCert, uploadPath.c_str(), autoTcfsPath.c_str(), 1) != 0)
                printf("***wallet 0 upload %s to %s failed\n", uploadPath.c_str(), autoTcfsPath.c_str());
            else
                printf("***wallet 0 upload %s to %s ok\n", uploadPath.c_str(), autoTcfsPath.c_str());        
        #define TREE_NODE_NUM  100
            TreeNodeT node[TREE_NODE_NUM];
            int realNum =0;
            if(TCFS_ListTree(&appCert, &userCert, autoTcfsPath.c_str(), node, TREE_NODE_NUM, &realNum) != 0)
                printf("***wallet 0 tree %s failed\n", autoTcfsPath.c_str());
            else
            {
                printf("***wallet 0 tree %s ok\n", autoTcfsPath.c_str());
                for(int i = 0; i < realNum; i++)
                {
                    printf("wallet 0 node %d[path:%s,hash:%s,ctime:%" PRIu64 ",size:%" PRIu64 ",type:%s]\n", i, node[i].path, node[i].hash, node[i].ctime, node[i].size, node[i].type?"dir":"file");
                }
            }
            if(TCFS_ListDir(&appCert, &userCert, autoTcfsPath.c_str(), 0, 100, node, TREE_NODE_NUM, &realNum) != 0)
                printf("***wallet 0 ls %s failed\n", autoTcfsPath.c_str());
            else
            {
                printf("***wallet 0 ls %s ok\n", autoTcfsPath.c_str());
                for(int i = 0; i < realNum; i++)
                {
                    printf("wallet 0 node %d[path:%s,hash:%s,ctime:%" PRIu64 ",size:%" PRIu64 ",type:%s]\n", i, node[i].path, node[i].hash, node[i].ctime, node[i].size, node[i].type?"dir":"file");
                }
            }
            std::string signTcfsPath;
            if(SignShareTcfsPath(curWalletIndex, wallet[1].address.c_str(), autoSignTcfsPath, signTcfsPath) != 0)
               printf("***wallet %d sign %s to wallet %d failed\n",curWalletIndex, autoSignTcfsPath.c_str(), 1);
            else
            {
                printf("***wallet %d sign %s to wallet %d ok\n",curWalletIndex, autoSignTcfsPath.c_str(), 1);               
                printf("signTcfsPath:%s\n", signTcfsPath.c_str());
            }
            if(processSign(1, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_Copy(&appCert, &userCert, signTcfsPath.c_str(), autoTcfsPath.c_str()) != 0)
                printf("***wallet 1 copy %s from wallet 0 to %s failed\n", signTcfsPath.c_str(), autoTcfsPath.c_str());
            else
            {
                printf("***wallet 1 copy %s from wallet 0 to %s ok\n", signTcfsPath.c_str(), autoTcfsPath.c_str());
            }
            if(TCFS_ListTree(&appCert, &userCert, autoTcfsPath.c_str(), node, TREE_NODE_NUM, &realNum) != 0)
                printf("***wallet 1 tree %s failed\n", autoTcfsPath.c_str());
            else
            {
                printf("***wallet 1 tree %s ok\n", autoTcfsPath.c_str());
                for(int i = 0; i < realNum; i++)
                {
                    printf("wallet 1 node %d[path:%s,hash:%s,ctime:%" PRIu64 ",size:%" PRIu64 ",type:%s]\n", i, node[i].path, node[i].hash, node[i].ctime, node[i].size, node[i].type?"dir":"file");
                }
            }
            if(TCFS_Delete(&appCert, &userCert, autoTcfsPath.c_str(), 1) != 0)
                printf("***wallet 1 Delete %s failed\n", autoTcfsPath.c_str());
            else
                printf("***wallet 1 Delete %s ok\n", autoTcfsPath.c_str());
                
            if(processSign(0, &appCert, &userCert) != 0)
                return -1;
            if(TCFS_Delete(&appCert, &userCert, autoTcfsPath.c_str(), 1) != 0)
                printf("***wallet 0 Delete %s failed\n", autoTcfsPath.c_str());
            else
                printf("***wallet 0 Delete %s ok\n", autoTcfsPath.c_str());
            printf("***************************loop:%d, now:%d**************************\n", loop, ++i);
            if(i < loop)
                goto start;

        }     
        else
        {
            printf("invalidate command caught!\n");
            printCmdHint();
            continue;
        }
    }
    TCFS_Uninit();
}

int main(int argc, char *argv[])
{
    std::vector<std::string> procCmd;

    if(argc >= 2)
    {
        for(int i = 1; i < argc; i++)
        {
            procCmd.push_back(argv[i]);
        }
        processCmd(procCmd, 0);
    }
    else
    {

        processCmd(procCmd, 1);
    }
    return 0;

}
